import java.io.File;
import java.util.Scanner;
/**
 * Proiectarea algoritmilor
 * Lab 2:  Greedy
 * Task 2: Planificarea temelor de catre studenti
 * 
 * @author adinu
 * @email  mandrei.dinu@gmail.com
 *
 */
public class HomeworkPlanner {
	
	public static final int NO_TESTS = 3;
	int[] homeworkCnt = new int[NO_TESTS]; // num of tasks to solve for each homework
	Homework[][] homework = new Homework[NO_TESTS][];	// lista de teme
	
	public static void main(String[] args) {
		HomeworkPlanner hp = new HomeworkPlanner();
		hp.readInput("date.in");
		hp.test();
	}
	
	private void test() {
		for (int t = 0; t < NO_TESTS; t++) {
			
			System.out.println("Pentru temele");
			printV(homework[t]);
			System.out.println();
			
			Homework[] solutie = chooseHomeworks(homework[t], t);
			System.out.println("Avem solutia\n");
			printV(solutie);
			System.out.println();
		}
	}
	
	private void readInput(String filename) {
		Scanner sc = null;
		
		try {
			sc = new Scanner(new File(filename));
			
			for (int t = 0; t < NO_TESTS; t++) {
				homeworkCnt[t] = sc.nextInt();
				homework[t] = new Homework[homeworkCnt[t]];
				int d, w;
				for (int i = 0; i < homeworkCnt[t]; i++) {
					 d = sc.nextInt();
					 w = sc.nextInt();
					 homework[t][i] = new Homework(d, w);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				if (sc != null) {
					sc.close();
				}
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}
	
	/**
	 * Make the best planification in time for a given set of tasks.
	 * @param  tasks
	 * @return a list of selected tasks
	 */
	Homework[] chooseHomeworks(Homework[] tasks, int _TEST_NO) {
		// TODO:
		// Adaugati true in isPlanned pe pozitia i, daca tema respectiva
		// a fost planificata.
		// Sortati lista de task-uri dupa deadline si alegeti intotdeauna
		// tema care se termina cel mai curand, in asa fel incat sa nu se suprapuna
		// cu nicio alta tema aleasa in trecut.
		boolean[] isPlanned = new boolean[homeworkCnt[_TEST_NO]];
		return null; // remove this
	}
	
	/**
	 * Prints on the screen an array of objects
	 * @param v
	 */
	private void printV(Object[] v) {
		if (v == null) {
			return;
		}
		System.out.print("{ ");
		for (Object elem : v){
			if (elem == null) {
				System.out.println("null");
			} else {
				System.out.print(elem + " ");
			}
		}
		System.out.print("}");
	}
	
	private class Homework {
		int deadline;
		int points;

		public Homework(int deadline, int points) {
			this.deadline = deadline;
			this.points = points;
		}

		@Override
		public String toString() {
			return "(d:" + deadline + ", p:" + points + ") ";
		}
	}
}
